<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/6/15
 * Time: 16:40
 */
namespace  App\Transformers\Post;

use App\Models\PostComment;
use App\Traits\UserTrait;
use Carbon\Carbon;
use League\Fractal\TransformerAbstract;

class CommentTransformer extends TransformerAbstract
{
    use UserTrait;
    public function transform(PostComment $postComment)
    {
        $replies = PostComment::where('parent_id', $postComment['id'])->orderBy('id', 'desc')->limit(2)->get();
        $reply = [];
        foreach($replies as $val){
            $userComment = $this->userInfo($val->uid);
            $replyUsername = '';
            if($val->reply_uid){
                $userReply = $this->userInfo($val->reply_uid);
                $replyUsername = $userReply['username'];
            }
            $reply[] = [
                'uid' => $val->uid,
                'username' => $userComment['username'],
                'avatar' => $userComment['avatar'],
                'reply_username' => $replyUsername,
                'content' => $val->is_delete?'该评论已被删除':$val->content,
                'created_at' => Carbon::parse($val->created_at)->diffForHumans(),
                'is_delete' => $val->is_delete,
            ];
        }
        $user = $this->userInfo($postComment['uid']);
        return [
            'id' => $postComment['id'],
            'uid' => $postComment['uid'],
            'username' => $user['username'],
            'avatar' => $user['avatar'],
            'content' => $postComment['is_delete']?'该评论已被删除':$postComment['content'],
            'created_at' => Carbon::parse($postComment['created_at'])->diffForHumans(),
            'reply_count' => $postComment->reply->count(),
            'reply' => $reply,
            'is_delete' => $postComment['is_delete'],
        ];
    }
}