<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/6/17
 * Time: 16:11
 */
namespace  App\Transformers\Post;

use App\Models\Post;
use App\Models\PostCollect;
use App\Models\PostComment;
use App\Models\PostDislike;
use App\Models\PostLike;
use App\Traits\UserTrait;
use Carbon\Carbon;
use League\Fractal\TransformerAbstract;

class PostTransformer extends TransformerAbstract
{
    use UserTrait;
    public function __construct()
    {
    }
    public function transform(Post $post)
    {
        $imgs = [];
        foreach($post->imgs as $img){
            $imgs[] = $img['img'];
        }

        $topic = [];
        foreach($post->topic() as $key => $val){
            $topic[] = [
                'id' => $key,
                'name' => $val
            ];
        }
        $user = $this->userInfo($post['uid']);
        return [
            'id' => $post['id'],
            'type' => $post['type'],
            'created_at' => $post['created_at'],
            'uid' => $post['uid'],
            'username' => $user['username'],
            'avatar' => $user['avatar'],
            'topic' => $topic,
            'title' => $post['title'],
            'content' => $post['content'],
            'location' => $post['location'],
            'img' => $post['img'],
            'imgs' => $imgs,
            'video' => $post['video'],
            'pv' => getNumber($post->data->pv),
            'praise_count' => $post->data->praise_count,
            'collect_count' => $post->data->collect_count,
            'comment_count' => $post->data->comment_count,
            'available_bean' => $post->data->available_bean,
            'will_collect_bean' => $post->data->will_collect_bean + 3 * $post->data->pv,
        ];
    }
}